//! # Text Structure Analysis
//!
//! This module provides functionality for analyzing the structural aspects of text,
//! such as segmentation into lines, paragraphs, and sentences.
//!
//! ## Key Components
//!
//! * `segmentation`: Analysis of text units (lines, paragraphs, sentences)
//!
//! The text module bridges character-level and token-level analysis by examining
//! how characters and tokens are organized into larger linguistic structures,
//! providing insights into document composition and readability.

pub mod segmentation;
